<?php

/**
 *  基础函数集成
 *  自定义添加小工具位置获取id函数
 *  清理文字函数 
 * @author url 	    http://www.themepark.com.cn
 * @author 		themepark
 * @package 	theme/functions
 * @version     1.o
 */



//自定义添加小工具位置获取id函数
function themepark_theme_widget_id($widget_id){
$themepark_theme_widget = get_option('themepark_theme_widget');
$themepark_theme_widget_id=get_option('themepark_theme_widget_id');

if($themepark_theme_widget){$themepark_theme_widgets=explode(",",$themepark_theme_widget);};
if($themepark_theme_widget_id){$themepark_theme_widget_ids=explode(",",$themepark_theme_widget_id);};


			$ii=-1;
			if($themepark_theme_widgets){ foreach ($themepark_theme_widgets as $a){
				$ii++;
				for($i=0;$i<count($themepark_theme_widget_ids);$i++)  {
					
					$checkbox=$themepark_theme_widget_ids[$ii];
					}
				if($widget_id===$checkbox){$selected='selected="selected"';}else{$selected='';}
				$widget_list.= '<option  value="'.$checkbox.'"'.$selected.'>'.$a.'</option>';
				
				
				} }
				
			return $widget_list;

};

//清理文字函数
function DeleteHtml($str) 
{ 
$str = trim($str); //清除字符串两边的空格
$str = preg_replace("/\t/","",$str); //使用正则表达式替换内容，如：空格，换行，并将替换为空。
$str = preg_replace("/\r\n/","",$str); 
$str = preg_replace("/\r/","",$str); 
$str = preg_replace("/\n/","",$str); 
$str = preg_replace("/ /","",$str);
return trim($str); //返回字符串
}
//注册菜单位置
register_nav_menus(
array(

'header-menu' => __( '菜单导航' ),
'cat-menu' => __( '导航下分类折叠菜单' ),
'tag-menu2' => __( '文章筛选菜单' ),
)
);
//略缩图获取以及默认图片
add_theme_support( 'post-thumbnails' );
 function themepark_thumbnails($thumbnail_size,$lazy){
	
	  $id =get_the_ID(); 
	  if(get_option('mytheme_'.$thumbnail_size.'_thumbnails')){$case_thumbnails=get_option('mytheme_'.$thumbnail_size.'_thumbnails');}else{$case_thumbnails= get_bloginfo('template_url').'/thumbnails/'.$thumbnail_size.'.jpg';} 
		 
		  $tit= get_the_title();
$post_thumbnail_id = get_post_thumbnail_id();
$src = wp_get_attachment_image_src( $post_thumbnail_id ,$thumbnail_size);
		 if (has_post_thumbnail()) {
		 echo '<img class="'.$lazy.' lazyload" alt="'.$tit.'" title="'.$tit.'" src="'.get_bloginfo('template_url').'/images/loading.png'.'"data-src="'.$src[0].'" />';
		 
		 
		 }else{
			 echo '<img alt="'.$tit.'" title="'.$tit.'" src="'.$case_thumbnails.'" />';
			 }
	 
	 }
//get略缩图函数	 
 function get_themepark_thumbnails($thumbnail_size,$lazy){
	  $id =get_the_ID(); 
	 if($lazy){$lazy="swiper-lazy";}
	 $post_thumbnail_id = get_post_thumbnail_id();
$src = wp_get_attachment_image_src( $post_thumbnail_id ,$thumbnail_size);
	  if(get_option('mytheme_'.$thumbnail_size.'_thumbnails')){$case_thumbnails=get_option('mytheme_'.$thumbnail_size.'_thumbnails');}else{$case_thumbnails= get_bloginfo('template_url').'/thumbnails/'.$thumbnail_size.'.jpg';} 
		 
		  $tit= get_the_title();

		 if (has_post_thumbnail()) { return get_the_post_thumbnail($thumbnail_size ,array('alt'=>$tit,'class' =>$lazy), true);}else{
			 return '<img alt="'.$tit.'" title="'.$tit.'" src="'.$case_thumbnails.'" />';
			 }
	  
	 
	 }	


 function get_themepark_thumbnails_hotimg($thumbnail_size){
	  $id =get_the_ID(); 
	 $hot_img=get_post_meta($id ,"hot_img", true); 
	 $post_thumbnail_id = get_post_thumbnail_id();
$src = wp_get_attachment_url( $post_thumbnail_id ,$thumbnail_size, true);
	 
		 
		  $tit= get_the_title();
if($hot_img){
			 return '<img class="left_post_pic lazyload" alt="'.$tit.'" title="'.$tit.'"src="'.get_bloginfo('template_url').'/images/loading.png'.'"data-src="'.$hot_img.'"  />';
			 }
		 elseif (has_post_thumbnail()) { return '<img class="left_post_pic lazyload" alt="'.$tit.'" title="'.$tit.'" src="'.get_bloginfo('template_url').'/images/loading.png'.'"data-src="'.$src.'" />';;}else{ return false;}
	  
	 
	 }	 


//去除wordpress头部输出的一些样式和脚本
if(!is_user_logged_in()){
remove_action( 'wp_head', 'print_emoji_detection_script', 7 );
remove_action( 'admin_print_scripts', 'print_emoji_detection_script' );
remove_action( 'wp_print_styles', 'print_emoji_styles' );
remove_action( 'admin_print_styles', 'print_emoji_styles' );
add_action( 'wp_print_styles',     'my_deregister_styles', 100 );
function my_deregister_styles()    { 

   wp_deregister_style( 'amethyst-dashicons-style' ); 
   wp_deregister_style( 'dashicons' ); 
 wp_deregister_script('thickbox');}
if ( !function_exists( 'disable_embeds_init' ) ) :
function disable_embeds_init(){
global $wp;
$wp->public_query_vars = array_diff($wp->public_query_vars, array('embed'));
remove_action('rest_api_init', 'wp_oembed_register_route');
add_filter('embed_oembed_discover', '__return_false');
remove_filter('oembed_dataparse', 'wp_filter_oembed_result', 10);
remove_action('wp_head', 'wp_oembed_add_discovery_links');
remove_action('wp_head', 'wp_oembed_add_host_js');
add_filter('tiny_mce_plugins', 'disable_embeds_tiny_mce_plugin');

}
add_action('init', 'disable_embeds_init', 9999);

endif;
}
if(!is_admin()){add_action( 'wp_enqueue_scripts', 'fanly_remove_block_library_css', 100 );}
function fanly_remove_block_library_css() {
	wp_dequeue_style( 'wp-block-library' );
}


//获取父级分类
function get_category_root_id($cat)
{
$this_category = get_term($cat,'product_cat');   // 取得当前分类
while($this_category->parent) // 若当前分类有上级分类时，循环
{
$this_category = get_term($this_category->parent,'product_cat'); // 将当前分类设为上级分类（往上爬）
}
return $this_category->term_id; // 返回根分类的id号
}


function get_category_root_id_n($cat)
{
$this_category = get_term($cat,'product_cat');   // 取得当前分类
	$n=0;
while($this_category->parent) // 若当前分类有上级分类时，循环
{
$this_category = get_term($this_category->parent,'product_cat'); 
	// 将当前分类设为上级分类（往上爬）
	$n=$n+1;
}
return $n; // 返回根分类的id号
}

//分页函数
    add_action( 'admin_menu', 'my_page_excerpt_meta_box' );
    function my_page_excerpt_meta_box() {
        add_meta_box( 'postexcerpt', __('Excerpt'), 'post_excerpt_meta_box', 'page', 'normal', 'core' );
    }
	
function par_pagenavi($range = 10){
$word_t3='<<';
$word_t4='<';
$word_t5='>';
$word_t6='>>';
global $paged, $wp_query;
$max_page='';
if ( !$max_page ) {$max_page = $wp_query->max_num_pages;}

if($max_page > 1){if(!$paged){$paged = 1;}

if($paged != 1){echo "<a href='" . get_pagenum_link(1) . "' class='extend'

title=' ".$word_t3."'> ".$word_t3." </a>";}

previous_posts_link($word_t4);

if($max_page > $range){

if($paged < $range){for($i = 1; $i <= ($range + 1); $i++)

{echo "<a href='" . get_pagenum_link($i) ."'";

if($i==$paged)echo " class='current'";echo ">$i</a>";}}

elseif($paged >= ($max_page - ceil(($range/2)))){

for($i = $max_page - $range; $i <= $max_page; $i++){echo "<a href='" . get_pagenum_link($i) ."'";

if($i==$paged)echo " class='current'";echo ">$i</a>";}}

elseif($paged >= $range && $paged < ($max_page - ceil(($range/2)))){

for($i = ($paged - ceil($range/2)); $i <= ($paged + ceil(($range/2))); $i++)

{echo "<a href='" . get_pagenum_link($i) ."'";if($i==$paged) echo " class='current'";echo ">$i</a>";}}}

else{for($i = 1; $i <= $max_page; $i++){echo "<a href='" . get_pagenum_link($i) ."'";

if($i==$paged)echo " class='current'";echo ">$i</a>";}}

next_posts_link($word_t5);

if($paged != $max_page){echo "<a href='" . get_pagenum_link($max_page) . "' class='extend'

title='".$word_t6."'>".$word_t6." </a>";}}

}
/*分页函数*/

//获取略缩图url
function get_post_thumbnail_url($post_id){
        $post_id = ( null === $post_id ) ? get_the_ID() : $post_id;
        $thumbnail_id = get_post_thumbnail_id($post->ID);
        if($thumbnail_id ){
                $thumb = wp_get_attachment_image_src($thumbnail_id, 'news-vedio-thumb');
                return $thumb[0];
        }else{
                return false;
        }
}
//增强编辑器开始
add_editor_style('/css/editor-style.css');  
function add_editor_buttons($buttons) {

$buttons[] = 'fontselect';

$buttons[] = 'fontsizeselect';

$buttons[] = 'cleanup';

$buttons[] = 'styleselect';

$buttons[] = 'hr';

$buttons[] = 'del';

$buttons[] = 'sub';

$buttons[] = 'sup';

$buttons[] = 'copy';

$buttons[] = 'paste';

$buttons[] = 'cut';

$buttons[] = 'undo';

$buttons[] = 'image';

$buttons[] = 'anchor';

$buttons[] = 'backcolor';

$buttons[] = 'wp_page';

$buttons[] = 'charmap';

return $buttons;

}

add_filter("mce_buttons_3", "add_editor_buttons");
//获取附件图片链接
function get_attachment_id_from_src ($link) {
    global $wpdb;
    $link = preg_replace('/-\d+x\d+(?=\.(jpg|jpeg|png|gif)$)/i', '', $link);
    return $wpdb->get_var("SELECT ID FROM {$wpdb->posts} WHERE guid='$link'");
};
 //阅读量统计 
function set_post_views() {   
  
    global $post;   
  
    $post_id = get_the_ID();   
    $count_key = 'views';   
    $count = get_post_meta($post_id, $count_key, true);   
  
    if (is_single() || is_page()) {   
  
        if ($count == '') {   
            delete_post_meta($post_id, $count_key);   
            add_post_meta($post_id, $count_key, '0');   
        } else {   
            update_post_meta($post_id, $count_key, $count + 1);   
        }   
  
    }   
  
}   
	add_action('get_header', 'set_post_views');  


function search_span_echo($mytheme_search_cat1,$sel,$all){
	$mytheme_search_text=get_themepark_option("mytheme_search_text",'输入搜索-');
	if($all){
		?>
 <span taxonomy="0" <?php echo 'post_type="0"';if($sel){echo 'class="sel"'; } ?>   category="" placeholder="<?php echo get_themepark_option('language_th5','全站搜索');  ?>"><i class="fas fa-check-square"></i><?php echo get_themepark_option('language_th5','全站搜索'); ?>
		 </span>
		<?php
	}
	if($mytheme_search_cat1) {	
	 	 ?>
	 	 <span taxonomy="<?php search_type_tp( get_term($mytheme_search_cat1)->taxonomy,'taxonomy') ?>" post_type="<?php search_type_tp( get_term($mytheme_search_cat1)->taxonomy,'post_tpye');echo '"';if($sel){echo 'class="sel"'; } ?>   category="<?php echo $mytheme_search_cat1; ?>" placeholder="<?php echo  $mytheme_search_text.get_term($mytheme_search_cat1)->name;  ?>"><i class="fas fa-check-square"></i><?php echo get_term($mytheme_search_cat1)->name; ?></span>
<?php
	  }
	
	
}



 function wptuts_add_color_picker( $hook ) {
        if( is_admin() ) { 
		    wp_enqueue_media();
            wp_enqueue_style( 'wp-color-picker' ); 
            wp_enqueue_script( 'custom-script-handle', get_template_directory_uri().'/js/custom-script.js', array( 'wp-color-picker' ), false, true ); 
			

        };

    };
add_filter( 'sidebar_admin_page', 'wptuts_add_color_picker' );
add_filter( 'customize_controls_print_scripts', 'wptuts_add_color_picker' );

add_filter( 'admin_head-nav-menus.php', 'menu_image_edit_nav_menu_walker_filter', 10, 2 );
 function menu_image_edit_nav_menu_walker_filter() {
			wp_enqueue_media();
			wp_enqueue_script( 'menu-image-admin', get_template_directory_uri() ."/js/widget_upload.js" );
	};

function first_img_as_thumbnail() {
$current_tag = single_tag_title('', false);
$tags = get_tags();
foreach($tags as $tag) {
if($tag->name == $current_tag) return $tag->term_id; 
};
};
function firstimgasthumbnail() {
global $post, $posts;
$first_img = '';
ob_start();
ob_end_clean();
$output = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $matches);
$first_img = $matches[1][0];
if(empty($first_img)){ 
$first_img = get_bloginfo('template_url').'/images/demo/vedio.gif';
}
$attachment_id = get_attachment_id_from_src(  $first_img );
return $attachment_id ;
} ;

function search_type_tp($id,$type){
	if($type=="post_tpye"){
		if($id=="category"){
			echo 'post';
			
		}elseif($id=="product_cat"){echo 'product';}
		
	}
	
	if($type=="taxonomy"){
		if($id=="category"){
			echo 'cat';
			
		}elseif($id=="product_cat"){echo 'tag_ID';}
		
	}
	
	
}

//给 wp_nav_menu 加上对象缓存，加快效率
add_filter( 'pre_wp_nav_menu', 'wpjam_get_nav_menu_cache', 10, 2 );
function wpjam_get_nav_menu_cache( $nav_menu, $args ) {
    $cache_key      = wpjam_get_nav_menu_cache_key($args);
    $cached_menu    = get_transient( $cache_key );
    if ( ! empty( $cached_menu ) )
        return $cached_menu;

    return $nav_menu;
}

add_filter( 'wp_nav_menu', 'wpjam_set_nav_menu_cache', 10, 2 );
function wpjam_set_nav_menu_cache( $nav_menu, $args ) {
    $cache_key      = wpjam_get_nav_menu_cache_key($args);
    set_transient( $cache_key, $nav_menu, 86400 );

    return $nav_menu;
}

function wpjam_get_nav_menu_cache_key($args){
    $timestamp = get_transient('nav-menu-cache-timestamp');
    if($time === false){
        $timestamp = time();
        set_transient( 'nav-menu-cache-timestamp', $time, 86400 );
    }
    return apply_filters( 'nav_menu_cache_key' , 'nav-menu-' . md5( serialize( $args ).serialize(get_queried_object()) ) . $timestamp );
}

// 更新菜单，清理缓存
add_action( 'wp_update_nav_menu', 'wpjam_delete_nav_menu_cache', 10, 3 );
function wpjam_delete_nav_menu_cache(){
    set_transient( 'nav-menu-cache-timestamp', time(), 86400 );
}


function add_meta_after_post(){
	if(is_single()&&show_fenxang('single')=='single'){
		
		$echo_meta=true;
	}
	if(is_page()&&show_fenxang('page')=='page'){
		
		$echo_meta=true;
	}
$mytheme_show_code = get_option('mytheme_show_code');	
	
$srs=str_replace("[this_post_url]",'<a style="color:#06C " href="'.get_permalink().'">'.get_permalink().'</a>',get_option('mytheme_fenxiang'));
	  
if(get_option('mytheme_fenxiang')&&$echo_meta){echo '<div class="meta_after_post">'.wpautop(trim(stripslashes($srs))).'</div>'; }
if($mytheme_show_code){  echo '<div class="show_code">',stripslashes($mytheme_show_code),'</div>' ; }

}
add_action( 'add_meta_after_the_content',  'add_meta_after_post' );
